---
title: Animations and tweens
slug: Games/Tutorials/2D_breakout_game_Phaser/Animations_and_tweens
tags:
  - 2D
  - Animation
  - Beginner
  - Canvas
  - Games
  - JavaScript
  - Phaser
  - Tutorial
  - tween
---
<div>{{GamesSidebar}}</div>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Extra_lives", "Games/Workflows/2D_Breakout_game_Phaser/Buttons")}}</p>

<div class="summary">
<p>This is the <strong>14th step</strong> out of 16 of the <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser">Gamedev Phaser tutorial</a>. You can find the source code as it should look after completing this lesson at <a href="https://github.com/end3r/Gamedev-Phaser-Content-Kit/blob/gh-pages/demos/lesson14.html">Gamedev-Phaser-Content-Kit/demos/lesson14.html</a>.</p>
</div>

<p><span class="seoSummary">To make the game look more juicy and alive we can use animations and tweens. This will result in a better, more entertaining experience. Let's explore how to implement Phaser animations and tweens in our game.</span></p>

<h2 id="Animations">Animations</h2>

<p>In Phaser, animations, involve taking a spritesheet from an external source and displaying the sprites sequentially. As an example, we will make the ball wobble when it hits something.</p>

<p>First of all, <a href="https://github.com/end3r/Gamedev-Phaser-Content-Kit/blob/gh-pages/demos/img/wobble.png">grab the spritesheet from Github</a> and save it in your <code>/img</code> directory.</p>

<p>Next, we will load the spritesheet — put the following line at the bottom of your <code>preload()</code> function:</p>

<pre class="brush: js notranslate">game.load.spritesheet('ball', 'img/wobble.png', 20, 20);
</pre>

<p>Instead of loading a single image of the ball we can load the whole spritesheet — a collection of different images. We will show the sprites sequentially to create the illusion of animation. The <code>spritesheet()</code> method's two extra paremeters determine the width and height of each single frame in the given spritesheet file, indicating to the program how to chop it up to get the individual frames.</p>

<h2 id="Loading_the_animation">Loading the animation</h2>

<p>Next up, go into your create() function, find the line that loads the ball sprite, and below it put the call to <code>animations.add()</code> seen below:</p>

<pre class="brush: js notranslate">ball = game.add.sprite(50, 250, 'ball');
ball.animations.add('wobble', [0,1,0,2,0,1,0,2,0], 24);
</pre>

<p>To add an animation to the object we use the <code>animations.add()</code> method, which contains the following parameters</p>

<ul>
 <li>The name we chose for the animation</li>
 <li>An array defining the order in which to display the frames during the animation. If you look again at the <code>wobble.png</code> image, you'll see there are three frames. Phaser extracts these and stores references to them in an array — positions 0, 1, and 2. The above array says that we are displaying frame 0, then 1, then 0, etc.</li>
 <li>The framerate, in fps. Since we are running the animation at 24fps and there are 9 frames, the animation will display just under three times per second.</li>
</ul>

<h2 id="Applying_the_animation_when_the_ball_hits_the_paddle">Applying the animation when the ball hits the paddle</h2>

<p>In the <code>arcade.collide()</code> method call that handles the collision between the ball and the paddle (the first line inside <code>update()</code>, see below) we can add an extra parameter that specifies a function to be executed every time the collision happens, in the same fashion as the <code>ballHitBrick()</code> function. Update the first line inside <code>update()</code> as shown below:</p>

<pre class="brush: js notranslate">function update() {
    game.physics.arcade.collide(ball, paddle, ballHitPaddle);
    game.physics.arcade.collide(ball, bricks, ballHitBrick);
    paddle.x = game.input.x || game.world.width*0.5;
}
</pre>

<p>Then we can create the <code>ballHitPaddle()</code> function (having <code>ball</code> and <code>paddle</code> as default parameters), playing the wobble animation when it is called. Add the following function just before your closing <code>&lt;/script&gt;</code> tag:</p>

<pre class="brush: js notranslate">function ballHitPaddle(ball, paddle) {
    ball.animations.play('wobble');
}
</pre>

<p>The animation is played every time the ball hits the paddle. You can add the <code>animations.play()</code> call inside the <code>ballHitBrick()</code> function too, if you feel it would make the game look better.</p>

<h2 id="Tweens">Tweens</h2>

<p>Whereas animations play external sprites sequentially, tweens smoothly animate properties of an object in the gameworld, such as width or opacity.</p>

<p>Let's add a tween to our game to make the bricks smoothly disappear when they are hit by the ball. Go to your <code>ballhitBrick()</code> function, find your <code>brick.kill();</code> line, and replace it with the following:</p>

<pre class="brush: js notranslate">var killTween = game.add.tween(brick.scale);
killTween.to({x:0,y:0}, 200, Phaser.Easing.Linear.None);
killTween.onComplete.addOnce(function(){
    brick.kill();
}, this);
killTween.start();
</pre>

<p>Let's walk through this so you can see what's happening here:</p>

<ol>
 <li>When defining a new tween you have to specify which property will be tweened — in our case, instead of hiding the bricks instantly when hit by the ball, we will make their width and height scale to zero, so they will nicely disappear. To the end, we use the <code>add.tween()</code> method, specifying <code>brick.scale</code> as the argument as this is what we want to tween.</li>
 <li>The <code>to()</code> method defines the state of the object at the end of the tween. It takes an object containing the chosen parameter's desired ending values (scale takes a scale value, 1 being 100% of size, 0 being 0% of size, etc.), the time of the tween in milliseconds and the type of easing to use for the tween.</li>
 <li>We will also add the optional <code>onComplete</code> event handler, which defines a function to be executed when the tween finishes.</li>
 <li>The last thing do to is to start the tween right away using <code>start()</code>.</li>
</ol>

<p>That's the expanded version of the tween definition, but we can also use the shorthand syntax:</p>

<pre class="brush: js notranslate">game.add.tween(brick.scale).to({x:2,y:2}, 500, Phaser.Easing.Elastic.Out, true, 100);
</pre>

<p>This tween will double the brick's scale in half a second using Elastic easing, will start automatically, and have a delay of 100 miliseconds.</p>

<h2 id="Compare_your_code">Compare your code</h2>

<p>You can check the finished code for this lesson in the live demo below, and play with it to understand better how it works:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/9o4pakrb/","","400")}}</p>

<h2 id="Next_steps">Next steps</h2>

<p>Animations and tweens look very nice, but we can add even more to our game — in the next section we'll look at handling <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser/Buttons">button</a> inputs.</p>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Extra_lives", "Games/Workflows/2D_Breakout_game_Phaser/Buttons")}}</p>
